package com.zoibackgroundlocation;


import android.Manifest;
import android.app.Notification;
import android.app.NotificationChannel;
import android.app.NotificationManager;
import android.app.Service;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.graphics.Color;
import android.location.Location;
//import android.location.LocationRequest;
import android.os.Build;
import android.os.IBinder;
import android.os.Looper;
import android.util.Log;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.annotation.RequiresApi;
import androidx.core.app.ActivityCompat;
import androidx.core.app.NotificationCompat;

import com.google.android.gms.location.FusedLocationProviderClient;
import com.google.android.gms.location.LocationCallback;
import com.google.android.gms.location.LocationRequest;
import com.google.android.gms.location.LocationResult;
import com.google.android.gms.location.LocationServices;
import com.google.android.gms.maps.model.LatLng;

import java.util.ArrayList;


public class LocationService extends Service {

  public static ArrayList<LatLng> locationArrayList = new ArrayList<LatLng>();

  public String url;
  public String id;
  FusedLocationProviderClient fusedLocationClient;
  LocationRequest locationRequest;
  LocationCallback locationCallback;


  // public LocationService(Promise response) {
  //     this.callback=response;
  // }


  private void startLocationUpdates() {
    if (ActivityCompat.checkSelfPermission(this, Manifest.permission.ACCESS_FINE_LOCATION) != PackageManager.PERMISSION_GRANTED && ActivityCompat.checkSelfPermission(this, Manifest.permission.ACCESS_COARSE_LOCATION) != PackageManager.PERMISSION_GRANTED) {
      // TODO: Consider calling
      //    ActivityCompat#requestPermissions
      // here to request the missing permissions, and then overriding
      //   public void onRequestPermissionsResult(int requestCode, String[] permissions,
      //                                          int[] grantResults)
      // to handle the case where the user grants the permission. See the documentation
      // for ActivityCompat#requestPermissions for more details.
      return;
    }
    fusedLocationClient.requestLocationUpdates(locationRequest,
      locationCallback,
      Looper.getMainLooper());
  }

  protected void createLocationRequest() {
    LocationRequest locationRequest = LocationRequest.create();

//        locationRequest.setInterval(1500000);

    locationRequest.setInterval(1*10000);

    locationRequest.setPriority(LocationRequest.PRIORITY_HIGH_ACCURACY);

    //   Toast.makeText(getApplicationContext(), "Started", Toast.LENGTH_LONG).show();
  }

  @Override
  public void onCreate() {
     Toast.makeText(getApplicationContext(), "Location Service started", Toast.LENGTH_LONG).show();
    super.onCreate();

    new Notification();

    fusedLocationClient = LocationServices.getFusedLocationProviderClient(this);

    if (Build.VERSION.SDK_INT > Build.VERSION_CODES.O) createNotificationChanel() ;
    else startForeground(
      1,
      new Notification()
    );

    locationRequest = LocationRequest.create();

//        locationRequest.setInterval(1500000);
    locationRequest.setInterval(1*10000);
    locationRequest.setFastestInterval(1*10000);
    //locationRequest.setMaxWaitTime(5000);
    locationRequest.setPriority(LocationRequest.PRIORITY_HIGH_ACCURACY);


    locationCallback = new LocationCallback() {
      @Override
      public void onLocationResult(@NonNull LocationResult locationResult) {



        Location location =  locationResult.getLastLocation();

        Intent sendLevel = new Intent();
        sendLevel.setAction("GET_LOCATION");
        sendLevel.putExtra( "Latitude",Double.toString(location.getLatitude()));
        sendLevel.putExtra( "Longitude",Double.toString(location.getLongitude()));

        sendBroadcast(sendLevel);


        //callback.resolve("hiiiii s");

//          Toast.makeText(getApplicationContext(),
//                  "Lat: "+Double.toString(location.getLatitude()) + '\n' +
//                          "Long: " + Double.toString(location.getLongitude()), Toast.LENGTH_LONG).show();

        Log.d("Location", Double.toString(location.getLatitude()) +","+Double.toString(location.getLongitude()));




        //locationArrayList.add(new LatLng(location.getLatitude(), location.getLongitude()));

               /* for (Location location : locationResult.getLocations()) {
                  location
                }*/
      }
    };
    startLocationUpdates();
  }


  @RequiresApi(api = Build.VERSION_CODES.O)
  private void createNotificationChanel() {
    String notificationChannelId = "Location channel id";
    String channelName = "Background Service";

    NotificationChannel chan = new NotificationChannel(
      notificationChannelId,
      channelName,
      NotificationManager.IMPORTANCE_NONE
    );
    chan.setLightColor(Color.BLUE);
    chan.setLockscreenVisibility(Notification.VISIBILITY_PRIVATE);

    NotificationManager manager = getSystemService(NotificationManager.class);

    manager.createNotificationChannel(chan);


    Notification notification = new NotificationCompat.Builder(this, notificationChannelId)
      .setContentTitle("SDL Location updates")
    //   .setSmallIcon(R.mipmap.ic_launcher)
      .setPriority(NotificationManager.IMPORTANCE_MIN)
      .setCategory(Notification.CATEGORY_SERVICE)
//                .setContentIntent(pendingIntent)
      .build();
    startForeground(2, notification);
  }

  @Override
  public int onStartCommand(Intent intent, int flags, int startId) {


//        Bundle extras = intent.getExtras();
//        if (extras == null) {
//            Log.d("Service", "null");
//        }
//        else {
//            url = (String) extras.get("url");
//            id = (String) extras.get("id");
//        }

    super.onStartCommand(intent, flags, startId);
    return START_STICKY;
  }

  @Override
  public void onDestroy() {
    super.onDestroy();
    Log.d("Location", "on close");

    Toast.makeText(getApplicationContext(), "closed", Toast.LENGTH_LONG).show();


    //   fusedLocationClient.removeLocationUpdates(locationCallback);
  }

  @Override
  public IBinder onBind(Intent intent) {
    Log.d("Location", "Bind");
    return null;
  }
}
